Package org.jcsp.plugNplay

# Class Times

java.lang.Object
org.jcsp.plugNplay.Times

All Implemented Interfaces:
  `CSProcess`

public final class Times extends Object implements CSProcess
Multiplies two `Integer` streams to one stream.

## Process Diagram

        in0  _______
       -->--|       | out
        in1 | Times |-->--
       -->--|_______|

## Description

`Times` is a process whose output stream is the product of the Integers on its input streams.

## Channel Protocols

Input Channels
in1,in2 | java.lang.Number | Both Channels can accept data from any subclass of Number. It is possible to send Floats down one channel and Integers down the other. However all values will be converted to ints.
Output Channels
out | java.lang.Integer | The output will always be of type Integer.

## Example

The following example shows how the use of this process in a small program. The program also uses some of the other building block processes. It generates two sequences of numbers, multiplies them together and prints them to the screen.

     import org.jcsp.lang.*;
     import org.jcsp.plugNplay.*;

     public class TimesExample {

       public static void main (String[] argv) {

         final One2OneChannel a = Channel.one2one ();
         final One2OneChannel b = Channel.one2one ();
         final One2OneChannel c = Channel.one2one ();

         new Parallel (
           new CSProcess[] {
             new Numbers (a.out ()),
             new Numbers (b.out ()),
             new Times (a.in (), b.in (), c.out ()),
             new Printer (c.in (), "--> ", "\n")
           }
         ).run ();

       }

     }

Author:
  P.H. Welch and P.D. Austin

## Constructor Summary

Constructors
Constructor
Description
`Times(ChannelInput in1, ChannelInput in2, ChannelOutput out)`
Construct a new Times process with the input Channels in1 and in2 and the output Channel out.

## Method Summary

Modifier and Type
Method
Description
`void`
`run()`
The main body of this process.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Times

public Times(ChannelInput in1, ChannelInput in2, ChannelOutput out)
Construct a new Times process with the input Channels in1 and in2 and the output Channel out. The ordering of the Channels in1 and in2 make no difference to the functionality of this process.

Parameters:
  `in1` - the first input Channel
  `in2` - the second input Channel
  `out` - the output Channel

## Method Details

### run

public void run()
The main body of this process.

Specified by:
  `run` in interface `CSProcess`